<template>
  <div class="aod-form">

    <table class="tinline my-4">
      <tbody>
        <tr v-if="agriContext">
          <td class="name">Contexte agricole:</td>
          <td class="value">{{ agriContext }}</td>
        </tr>
        <tr v-if="resourceToProtect">
          <td class="name">Ressource à protéger:</td>
          <td class="value">{{ resourceToProtect }}</td>
        </tr>
        <tr v-if="selectedTransferMode">
          <td class="name">Mode de transfert:</td>
          <td class="value">{{ selectedTransferMode }}</td>
        </tr>
        <tr v-if="selectedTransferModeAmont">
          <td class="name">Mode de transfert amont:</td>
          <td class="value">{{ selectedTransferModeAmont }}</td>
        </tr>
        <tr v-if="selectedMethodo">
          <td class="name">Méthodologie:</td>
          <td class="value">{{ selectedMethodo }}</td>
        </tr>
        <tr v-if="selectedParameter">
          <td class="name">Polluant problématique:</td>
          <td class="value">{{ getPollutantName(selectedPollutant) }}</td>
        </tr>
      </tbody>
    </table>

    <form v-if="currentCrumb.id === 1">

      <div class="form-selector">
        <label>Afficher les couches: </label>
        <LayerTree category='tool-base'/>
      </div>

      <div class="form-selector">
        <label for="resource">Quel est le contexte agricole?</label>
        <select class="form-select" id="resource" @change="setAgriContext($event)" :value=getAgriContext()>
          <option value="''" disabled selected>Contexte agricole</option>
          <option value="grandes-cultures">Grandes cultures</option>
          <option value="prairies">Prairies</option>
        </select>
      </div>

      <div v-if="displayResourceQuestion()" class="form-selector">
        <label for="resource">Quelle est la ressource à protéger?</label>
        <select class="form-select" id="resource" @change="setResourceToProtect($event)" :value=getSelectedResource()>
          <option value="''" disabled selected>Ressource à protéger</option>
          <option value="surface">Eau de surface</option>
          <option value="souterraine">Eau souterraine</option>
        </select>
      </div>
      <div v-if="displayModeTransferQuestion()" class="form-selector">
        <label for="mode-transfer">Principal mode de transfert</label>
        <select class="form-select" id="mode-transfer" @change="setSelectedTransferMode($event)" :value=getSelectedTransferMode()>
          <option value="''" disabled selected>Mode de transfert</option>
          <option v-for="t in transferModes" :value="t.id" :key="t.id" >{{ t.name }}</option>
        </select>
      </div>
      <div v-if="displayTransferAmontQuestion()" class="form-selector">
        <label for="transfer-amount">Principal mode de transfert problématique depuis l'amont vers la zone d'infiltration</label>
        <select class="form-select" id="transfer-amount" @change="setSelectedTransferModeAmont($event)" :value=getSelectedTransferModeAmont()>
          <option value="''" disabled selected>Mode de transfert</option>
          <option v-for="ta in transferModesAmont" :value="ta.id" :key="ta.id">{{ ta.name }}</option>
        </select>
      </div>
      <div class="methodo-msg" v-if="displayResponse()">
        {{ methodoFormMessage }}
        <a v-if="methodoFormMessage.includes('haie')" target= "_blank" :href="makeFileUrl('haie.pdf')">Haies
          <i class="fa fa-fw fa-info-circle" title="Fiches informatives">
          </i>
        </a>
        <a v-if="methodoFormMessage.includes('alignements d\'arbres')" target= "_blank" :href="makeFileUrl('8_Alignement_arbres.pdf')">Alignement d'arbres
          <i class="fa fa-fw fa-info-circle" title="Fiches informatives">
          </i>
        </a>
        <a v-if="methodoFormMessage.includes('Fossé')" target= "_blank" :href="makeFileUrl('9_Fosse_vegetalise.pdf')">Fossés végétalisés
          <i class="fa fa-fw fa-info-circle" title="Fiches informatives">
          </i>
        </a>
        <a v-if="methodoFormMessage.includes('Zone tampon humide')" target= "_blank" :href="makeFileUrl('zone-tampon-humide-artificielle.pdf')">Zone tampon humide artificielle
          <i class="fa fa-fw fa-info-circle" title="Fiches informatives">
          </i>
        </a>
      </div>
    </form>

    <template v-else-if="currentCrumb.id === 2">
      <form>
        <div class="form-selector">
          <label for="polluant">Quel est le polluant problématique?</label>
          <select class="form-select" id="polluant" @change="setPollutant($event)" :value=getSelectedParameter()>
            <option value="''" disabled selected>Polluant problématique</option>
            <option v-for="pollutant in store.getters.getPollutants" :value="pollutant.id" :key="pollutant.id">
              {{ pollutant.name }}
            </option>
          </select>
        </div>
      </form>
      <div class="solution-graph" v-if="selectedPollutant">
        <h5>Efficacité</h5>
        <div class="tinline my-4">
          <div class="sol-chart-header">
            <div class="header-col-1"><p>Solutions</p></div>
            <div class="header-col-2"><p>Efficacité</p></div>
          </div>
          <div>
            <div class="chart-lines">
              <div class="solution-chart" v-if="store.state.selectedMethodo === 'methodo2'">
                <p class="mt-3">Amont</p>
                <solution-graph v-for="(s, i) in orderedSolutions('amont')" :solution="s" :key="i"/>
                <p class="mt-3">Milieu</p>
                <solution-graph v-for="(s, i) in orderedSolutions('milieu')" :solution="s" :key="i"/>
                <p class="mt-3">Aval</p>
                <solution-graph v-for="(s, i) in orderedSolutions('aval')" :solution="s" :key="i"/>
              </div>
              <div class="solution-chart" v-else>
                <solution-graph v-for="(s, i) in orderedSolutions()" :solution="s" :key="i"/>
              </div>
            </div>
          </div>
        </div>
      </div>
    </template>

    <template v-else-if="currentCrumb.id === 3">
      <div class="input">
        <div>
          <h5>1. Identifier les chemins de l'eau</h5>
          <p class="help">Télécharger la fiche informative sur les chemins de l'eau
            <a target="_blank" :href="makeFileUrl('Annexe8_Chemins_eau.pdf')">
              <i class="fa fa-fw fa-info-circle" title="Chemins de l'eau"></i>
            </a>
          </p>
          <p class="help">Afficher des couches pour les identifier</p>
          <LayerTree category='tool-info'/>
        </div>

        <div class="d-grid gap-2">
          <h5>2. Dessiner des lignes</h5>
          <button class="btn btn-outline-light draw-btn" v-if="isDrawing" @click="toggleDraw('')">
            Arrêter de dessiner
          </button>
          <div class="btn-wrapper" v-else>
            <button class="btn btn-outline-light draw-btn" @click="toggleDraw('lines')">
              <i class="fa fa-fw fa-pencil"></i>Dessiner des solutions
            </button>
            <button v-if="store.state.selectedMethodo === 'methodo2'" class="btn btn-outline-light draw-btn" @click="toggleDraw('axe')">
              <i class="fa fa-fw fa-pencil"></i>Dessiner l'axe d'écoulement
            </button>
            <button class="btn btn-outline-light draw-btn" @click="toggleDraw('zone')">
              <i class="fa fa-fw fa-pencil"></i>Dessiner une zone vulnérable
            </button>
          </div>
        </div>

      </div>
    </template>

    <template v-else-if="currentCrumb.id === 4">
      <div class="input">

        <div class="my-4 form-selector">
          <h5>1. Choisir un nombre de scénarios à comparer</h5>
          <input class="form-control" style="width: 60%;" min="0" max="10" type="number" @input="setScenarii"/>
        </div>

        <div class="my-4 form-selector" v-if="store.state.selectedMethodo === 'methodo2'">
          <label>Quelle est la surface (en ha) du bassin versant contributif?</label>
          <input class="form-control" style="width: 60%;" min="0" type="number" @input="setWatershedSurface" :value=getWatershedSurface() />
        </div>

        <div class="my-4 form-selector" v-if="store.state.selectedMethodo === 'methodo2'">
          <label>La zone d'implantation en aval est-elle le long d'un cours d'eau? ?</label>
          <input class="form-check-input"
            type="checkbox"
            id="normales"
            name="normales"
            :checked=getCoursDeau()
            @change="setCoursDeau($event)">
        </div>

        <div class="my-4">
          <h5>2. Choisir des solutions pour chaque scénario</h5>

          <p class="help">Afficher des couches pour choisir les solutions</p>
          <LayerTree category='tool-drawing'/>

          <div v-if="store.state.selectedMethodo === 'methodo2'" class="mb-3">
            <h5>L'axe d'écoulement</h5>
            <p><span style="font-weight: bold">Longueur: </span>{{ getFlowLength() }}m</p>
          </div>

          <div class="mb-3" v-for="s in scenarii.sort((a, b) => a.id - b.id)" :key="s.id">
            <h5>Scénario {{ s.id }}</h5>

            <ul class="lines-list fa-ul">
              <li class="form-selector" v-for="l in getLinesByScenario(s.id).sort((a, b) => a.id - b.id)" :key="l.id">
                <i class="fa fa-li fa-minus"></i>
                <label>Ligne {{ l.id }}:
                  <span v-if="store.state.selectedMethodo === 'methodo1'">{{ formatLength(l.length) }}
                  </span>
                </label>
                <select
                  v-if="store.state.selectedMethodo === 'methodo2'"
                  class="form-select"
                  @change="setFlowPositionToLine($event, l.id)"
                  :value=getFlowPosition(l.id)
                  >
                  <option value="''" disabled selected>Choisir une position</option>
                  <option v-for="p in flowPositions(l.id)" :key="p" >{{ p }}</option>
                </select>
                <select class="form-select" @change="setSolutionToLine($event, s.id, l.id)" :value="getSolutionId(s.id, l.id)">
                  <option value="''" disabled selected>Choisir une solution</option>
                  <option v-if="store.state.selectedMethodo === 'methodo2'" value=-1 >Pas de solution implémentée</option>
                  <option v-for="s in orderedSolutions(l?.flowPosition)" :value="s.id" :key="s.id" >{{ s.name }}</option>
                </select>
              </li>
            </ul>
          </div>

        </div>

      </div>
    </template>

    <template v-else-if="currentCrumb.id === 5">
      <div>
        <h4>Résultats</h4>
        <p class="help">Voir les résultats ci-contre</p>

        <h5>Scenarii choisis</h5>
        <ul class="lines-list fa-ul" v-for="s in scenarii" :key="s.id">
          <label>Scénario {{ s.id }}</label>
          <li class="form-selector" v-for="l in s.lines" :key="l.id">
            <i class="fa fa-li fa-minus"></i>
            <label>Ligne {{ l.id }}:
              <span v-if="store.state.selectedMethodo === 'methodo1'">{{ formatLength(l.length) }}
              </span>
            </label>
            <span class="solution-label">{{ getLineSolution(l) }}</span>
            <span class="solution-label flow" v-if="store.state.selectedMethodo === 'methodo2'">({{ l.flowPosition }})</span>
          </li>
        </ul>

        <div class="text-end">
          <a @click="tableToCSV" title="Télécharger les résultats">
            <i class="fa fa-download fa-fw"></i> Télécharger
          </a>
        </div>
      </div>
    </template>

  </div>
</template>

<script lang="ts">
import {useStore} from '../store'
import {computed, defineComponent} from 'vue'
import {getEfficacite, getSolutionSlug} from '../calculator';
import {AgriContext, DrawingState, FlowPosition, LineDrawn, OrderedSolution, ResourceToProtectType, Scenario, Solution} from '../utils/_types';
import {STATIC_URL} from '../utils/_static';
import LayerTree from './LayerTree.vue';
import SolutionGraph from "./SolutionGraph.vue";

export default defineComponent({
  name: 'Form',
  components: {SolutionGraph, LayerTree },
  setup: () => {

    const store = useStore();

    const updateForm = (_event) => {

      store.commit('setSelectedMethodo', null);

      if(store.state.selectedTransferMode) {
        const tm = store.state.transferModes.find(t => t.id === store.state.selectedTransferMode);
        if (tm?.form_action === 'methodo1' || tm?.form_action === 'methodo2') {
          store.commit('setSelectedMethodo', tm?.form_action);
        }
        if (tm?.form_action === 'print') {
          store.commit('setMethodoFormMessage', tm?.form_text);
          store.commit('setMethodoFormState', 'reponse');
        }
        if (tm?.form_action === 'subform') {
          store.commit('setMethodoFormState', 'choixModePrincipalAmont');
          const tma = store.state.transferModesAmont.find(t => t.id === store.state.selectedTransferModeAmont);
          store.commit('setMethodoFormMessage', tma?.form_text);
          store.commit('setSelectedMethodo', tma?.form_action);
        }
      }
      store.dispatch('setValidatedStep');
    };

    const getAgriContext = () => store.state.agriContext ?? "''";

    const setAgriContext = (event) => {
      store.commit('setAgriContext', event.target.value as AgriContext);
    };

    const getSelectedResource = () => store.state.resourceToProtect ?? "''";

    const setResourceToProtect = (event) => {
      resetPollutant();
      resetTransferModeSelectors();
      store.dispatch('setResourceToProtect', event.target.value as ResourceToProtectType);
      store.commit('setMethodoFormState', 'choixModePrincipal');
      updateForm(event);
    };

    const getSelectedTransferMode = () => store.state.selectedTransferMode ?? "''";

    const setSelectedTransferMode = (event) => {
      store.commit('setSelectedTransferModeAmont', null);
      store.commit('setMethodoFormState', 'choixModePrincipal');
      store.commit('setMethodoFormMessage', null);
      store.commit('setSelectedTransferMode', Number(event.target.value));
      updateForm(event);
    };

    const getSelectedTransferModeAmont = () => store.state.selectedTransferModeAmont ?? "''";

    const setSelectedTransferModeAmont = (event) => {
      store.commit('setSelectedTransferModeAmont', Number(event.target.value));
      updateForm(event);
    };

    const getSelectedParameter = () => store.state.selectedParameter ?? "''";

    const getSelectedPollutant = () => store.state.pollutant ?? "''";

    const setPollutant = (event) => {
      store.commit('setSelectedParameter', Number(event.target.value));
      store.commit('setPollutant', Number(event.target.value)); //TODO not very clean...
    }

    const setSolutionToLine = (event, scenarioId: number, lineId: number) => {
      const value = Number(event.target.value) !== -1 ? Number(event.target.value) : null;
      store.commit('addSolutionToLine', {scenarioId: scenarioId, lineId: lineId, solutionId: value});
      updateForm(event);
    };

    const resetPollutant = () => store.commit('setPollutant', null);
    const setFlowPositionToLine = (event, lineId: number) => {
      store.commit('addFlowPositionToLine', {lineId: lineId, flowPosition: event.target.value});
    };

    const resetTransferModeSelectors = () => {
      store.commit('setSelectedTransferMode', null);
      store.commit('setSelectedTransferModeAmont', null);
    };

    const getPollutantSlug = (pollutantId: number|null): string =>
      store.state.parameters.filter((p) => p.id === Number(pollutantId))[0]?.slug;

    const getPollutantName = (pollutantId: number|null): string =>
      store.state.parameters.filter((p) => p.id === Number(pollutantId))[0]?.name;

    const getMethodoNumber = (): string => store.state.selectedMethodo
      ? store.state.selectedMethodo.slice(-1)
      : '1';

    const orderedSolutions = (flowPosition: FlowPosition = 'milieu') => {
      let orderedSolutions: OrderedSolution[] = [];
      const solutions: Solution[] = store.state.solutions.filter(
        (s: Solution) => s.methodology === getMethodoNumber()
      ).filter((s: Solution) => {
        if (getSolutionSlug(s.id) === 'chenal-enherbe_2' && (flowPosition === 'aval' || flowPosition === 'amont')) {
          return false;
        }
        if (getSolutionSlug(s.id) === 'ripisylve_2' && (flowPosition === 'milieu' || flowPosition === 'amont')) {
          return false;
        }
        if (getSolutionSlug(s.id) === 'ripisylve-bande-enherbee_2' && (flowPosition === 'milieu' || flowPosition === 'amont')) {
          return false;
        }
        return !(getSolutionSlug(s.id) === 'zone-tampon-humide-artificielle_2' && (flowPosition === 'milieu' || flowPosition === 'amont'));
      });

      solutions.forEach(s => {
        const polluantSlug = getPollutantSlug(store.state.pollutant);
        const efficacite = getEfficacite(store.state.cotations, getMethodoNumber(), polluantSlug, s.slug, flowPosition);
        orderedSolutions.push(
          {
            id: s.id,
            name: s.name,
            efficacite: efficacite,
            slug: s.slug
          }
        )
      });
      return orderedSolutions.sort((a, b) => b.efficacite - a.efficacite);
    };

    const flowPositions = (lineId: number): FlowPosition[] => {
      let positions = [
        'amont' as FlowPosition,
        'milieu' as FlowPosition,
        'aval' as FlowPosition
      ];
      if (store.state.scenarii[0]) {
        for (const l of store.state.scenarii[0]?.lines) {
          if (l.id !== lineId) {
            if (l?.flowPosition) {
              positions = positions.filter((p: FlowPosition) => p != l?.flowPosition)
            }
          }
        }
      }
      return positions;
    };

    const toggleDraw = (type: 'lines' | 'axe' | 'zone' | '') =>
      store.commit('setDrawState', {isDrawing: !store.state.drawState.isDrawing, type: type});

    const formatLength = (length: number): string =>
      length > 100
        ? Math.round((length / 1000) * 100) / 100 + ' ' + 'km'
        : Math.round(length * 100) / 100 + ' ' + 'm';

    const getLineSolution = (line: LineDrawn): string =>
      store.state.solutions.find((s: Solution) => s.id === line.solutionId)?.name ?? "";

    const setScenarii = (event) => {
      const nScenarii = Number(event.target.value);
      const scenarii = store.state.scenarii;
      const lines = store.state.linesDrawn.filter(l => l.line.get('name') === 'solutionLine').map(l => ({
        id: l.id,
        line: l.line,
        length: l.length,
      }));
      while (scenarii.length > nScenarii) {
        scenarii.pop();
      }
      while (scenarii.length < nScenarii) {
        const newScenario = {
          id: scenarii.length + 1, //TODO, check if this id remains consistent!
          lines: lines
        };
        scenarii.push(newScenario);
      }
      store.commit('setScenarii', scenarii);
    }

    const getFlowLength = (): string => store.state.flowLength.toFixed(2);

    const setWatershedSurface = (event) => store.commit('setWatershedSurface', Number(event.target.value));
    const getWatershedSurface = (): number => store.state.watershedSurface;

    const setCoursDeau = (event) => store.commit('setCoursDeau', event.target.value);
    const getCoursDeau = (): boolean => store.state.coursDeau;

    const getLinesByScenario = (scenarioId: number): LineDrawn[] => {
      const scenario = store.state.scenarii.find((s) => s.id === scenarioId);
      return scenario?.lines ?? [];
    }

    const getFlowPosition = (lineId: number): string|undefined => {
      for (const s of store.state.scenarii) {
        let line: LineDrawn|undefined = s.lines.find((l: LineDrawn) => l.id === lineId);
        if (line?.flowPosition) {
          return line.flowPosition;
        }
      }
      return undefined;
    }

    const getSolutionId = (scenarioId: number, lineId: number): number => {
      const scenario = store.state.scenarii.find((s) => s.id === scenarioId);
      const line = scenario?.lines.find((l) => l.id === lineId);
      return line?.solutionId ?? -1;
    };

    const displayResponse = (): boolean =>
      store.state.methodoFormState === 'reponse';

    const displayTransferAmontQuestion = (): boolean =>
      store.state.methodoFormState === 'choixModePrincipalAmont';

    const displayModeTransferQuestion = (): boolean =>
      store.state.methodoFormState === 'choixModePrincipal' ||
        displayTransferAmontQuestion() ||
        displayResponse();

    const displayResourceQuestion = (): boolean =>
      store.state.methodoFormState === 'init' ||
          displayModeTransferQuestion()

    const downloadFile = (csvData: string) => {
      const CSVFile = new Blob([csvData], { type: "text/csv" })
      const tempLink = document.createElement('a');

      console.log(CSVFile);

      tempLink.download = "results.csv";
      tempLink.href = window.URL.createObjectURL(CSVFile);

      tempLink.style.display = "none";
      document.body.appendChild(tempLink);

      tempLink.click();
      document.body.removeChild(tempLink);
    }

    const tableToCSV = () => {
      const table = document.getElementsByClassName('table');
      let csv_data : string | string[] = [];

      const rows = table[0].getElementsByTagName('tr');
      for (let i = 0; i < rows.length; i++) {
        const cols = rows[i].querySelectorAll('td,th');

        if (i !== 0) {
          const csvRow : string[] = [];
          for (let j = 0; j < cols.length; j++) {
            csvRow.push((cols[j].innerHTML).replace(/,/g, ''));
          }
          csv_data.push(csvRow.join(","));
        }
      }
      csv_data = csv_data.join('\n');

      downloadFile(csv_data);
    }

    const makeFileUrl = (identifier: string): string => `${STATIC_URL}${identifier}`;

    return {
      store,
      axe: computed(() => store.state.linesDrawn.filter(l => l.line.get('name') === 'axeLine')),
      orderedSolutions,
      flowPositions,
      setAgriContext,
      setResourceToProtect,
      setSelectedTransferMode,
      setSelectedTransferModeAmont,
      setPollutant,
      setSolutionToLine,
      setFlowPositionToLine,
      toggleDraw,
      displayResourceQuestion,
      displayModeTransferQuestion,
      displayTransferAmontQuestion,
      displayResponse,
      formatLength,
      getAgriContext,
      getSelectedTransferMode,
      getSelectedTransferModeAmont,
      getSelectedPollutant,
      getPollutantName,
      getFlowPosition,
      getSelectedParameter,
      getSelectedResource,
      getLineSolution,
      getFlowLength,
      getWatershedSurface,
      getCoursDeau,
      setScenarii,
      setWatershedSurface,
      setCoursDeau,
      getLinesByScenario,
      getSolutionId,
      tableToCSV,
      makeFileUrl,
      agriContext: computed(() => store.state.agriContext
        ? (store.state.agriContext === 'grandes-cultures' ? 'Grandes cultures' : 'Prairies')
        : null
      ),
      transferModes: computed(() => store.state.transferModes),
      transferModesAmont: computed (() => store.state.transferModesAmont),
      currentCrumb: computed(() => store.state.currentCrumb),
      methodoFormMessage: computed(() => store.state.methodoFormMessage),
      resourceToProtect: computed(() => store.state.resourceToProtect
        ? (store.state.resourceToProtect === 'surface' ? 'Eau de surface' : 'Eau souterraine')
        : null
      ),
      selectedTransferMode: computed(() =>
        store.state.transferModes.find(
          (t) => t.id === store.state.selectedTransferMode
        )?.name),
      selectedTransferModeAmont: computed(() =>
        store.state.transferModesAmont.find(
          (t) => t.id === store.state.selectedTransferModeAmont
        )?.name),
      selectedMethodo: computed(() => store.state.selectedMethodo
        ? (store.state.selectedMethodo === 'methodo1' ? 'Méthodologie 1' : 'Méthodologie 2')
        : null
      ),
      selectedPollutant: computed(() => store.state.pollutant),
      selectedParameter: computed(() =>
        store.state.parameters.find(
            (p) => p.id === (store.state.selectedParameter)
          )?.name),
      isDrawing: computed(() => store.state.drawState.isDrawing),
      lines: computed(() => store.state.linesDrawn),
      scenarii: computed(() => store.state.scenarii),
      parameters: computed(() => store.state.parameters),
    }
  }
})
</script>

<style lang="scss" scoped>
div.btn-wrapper {
  display: flex;
  justify-content: space-around;
  button {
    margin: 4px;
  }
}
button.draw-btn {
  width: 40% !important;
}
</style>
